var template = ''
$.ajax('../../../component/statistics/CallRecord/index.html', {
  data: {},
  dataType: 'html',
  cache: false,
  timeout: 60000,
  async: false,
  error: function (res) {},
  success: function (res) {
    template = res
  }
})

Vue.component('call-record', {
  template: template,
  props: [],
  data: function () {
    return {
      chooseTime: null,
      form: {},
      tableData: [],
      tableHeader: [
        { label: '报警人', prop: 'doctorName' },
        { label: '手机号码', prop: 'phone' },
        { label: '报警时间', prop: 'createTime' },
        { label: '业务来源', prop: 'typeName' },
        { label: '患者姓名', prop: 'patientName' },
        { label: '身份证号', prop: 'idcard' },
        { label: '联系电话', prop: 'mobile' },
        { label: '家庭住址', prop: 'address' }
      ],
      page: 1,
      size: 10,
      total: 0,
      loading: false,
      exportLoading: false
    }
  },
  methods: {
    queryDate() {
      this.page = 1
      this.getList()
    },
    exportTable() {
      var vm = this
      var params = {
        ...this.form,
        page: this.page,
        pageSize: this.size
      }
      if (this.chooseTime) {
        params.startDate = this.chooseTime[0]
        params.endDate = this.chooseTime[1]
      }
      this.exportLoading = true
      var fileName = `报警记录${new Date().getTime()}.xls`
      httpRequest.downLoadFileForAjax('doctor/familyBed/exportCallRecordPage', fileName, params).then(function(){
        vm.exportLoading = false
      })
    },
    eliminateClick() {
      this.form = {}
      this.chooseTime = null
    },
    getList() {
      var vm = this
      this.loading = true
      var params = {
        ...this.form,
        page: this.page,
        pageSize: this.size
      }
      if (this.chooseTime) {
        params.startDate = this.chooseTime[0]
        params.endDate = this.chooseTime[1]
      }
      httpRequest.get('doctor/familyBed/callRecordPage', { data: params }).then(function (res) {
        if(res.status == 200){
          vm.tableData = res.detailModelList
          vm.total = res.totalCount
        }
        vm.loading = false
      })
    },
    handleCurrentChange(val) {
      this.page = val
      this.getList()
    },
    handleSizeChange(val) {
      this.size = val
      this.getList()
    }
  },
  mounted() {
    this.getList()
  }
})
