var template = ''
$.ajax('../../../component/statistics/GxbEvaluation/index.html', {
  data: {},
  dataType: 'html',
  cache: false,
  timeout: 60000,
  async: false,
  error: function (res) {},
  success: function (res) {
    template = res
  }
})

Vue.component('gxb-evaluation', {
  template: template,
  props: [],
  data: function () {
    return {
      years: [],
      yearType: '1',
      chooseYear: null,
      chooseTime: null,
      rangeOptions: [
        { label: '区', value: 'town' },
        { label: '社区', value: 'hospital' },
        { label: '团队', value: 'team' }
      ],
      areaOptions: [
        { label: '思明区', value: '350203' },
        { label: '海沧区', value: '350205' },
        { label: '湖里区', value: '350206' },
        { label: '集美区', value: '350211' },
        { label: '同安区', value: '350212' },
        { label: '翔安区', value: '350213' }
      ],
      hospitalOptions: [],
      teamOptions: [],
      form: {
        range: 'town'
      },
      loading: false,
      exportLoading: false,
      tableData: [],
      tableHeader: [],
      constantHeader: [
        { label: '评估人数', prop: 'totalNum', width: '90' },
        { label: '日常评估人数', prop: 'dailyNum', width: '110' },
        { label: '住院补筛人数', prop: 'inScreenNum', width: '110' },
        { label: '低危人数', prop: 'lRiskNum', width: '90' },
        { label: '中危人数', prop: 'mRiskNum', width: '90' },
        { label: '高危人数', prop: 'hRiskNum', width: '90' },
        { label: '极高危人数', prop: 'uhRiskNum', width: '90' },
        { label: '超高危人数', prop: 'ehRiskNum', width: '90' },
        { label: '已筛次数', prop: 'totalTimes', width: '90' },
        { label: '低危次数', prop: 'lRiskTimes', width: '90' },
        { label: '中危次数', prop: 'mRiskTimes', width: '90' },
        { label: '高危次数', prop: 'hRiskTimes', width: '90' },
        { label: '极高危次数', prop: 'uhRiskTimes', width: '90' },
        { label: '超高危次数', prop: 'ehRiskTimes', width: '90' },
        { label: '上转人次', prop: 'turnUpNum', width: '90' },
        { label: '消息提醒人次', prop: 'messageTimes', width: '110' },
        { label: '社区随访人次', prop: 'hosFollowNum', width: '110' }
      ],
      // page: 1,
      // size: 10,
      // total: 0,
      level: 0,
      visible: false,
      title: '',
      query: {},
      dataRangeOption: [],
      dialogTableData: [],
      dialogHeader: [],
      page: 1,
      size: 10,
      total: 0,
      messageVisible: false,
      messInfo: null,
      remind: '',
      dialogExportLoading: false,
      dialogLoading: false
    }
  },
  methods: {
    init() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (selectedRole.code.indexOf('350200') > -1) {
        this.level = 1 //  市卫健委
        this.areaOptions = [
          { label: '厦门市', value: '' },
          { label: '思明区', value: '350203' },
          { label: '海沧区', value: '350205' },
          { label: '湖里区', value: '350206' },
          { label: '集美区', value: '350211' },
          { label: '同安区', value: '350212' },
          { label: '翔安区', value: '350213' }
        ]
      } else if (selectedRole.code.length == 6) {
        this.level = 2 // 区管理
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code }]
        this.form = {
          range: 'town',
          area: selectedRole.code
        }
        this.getHospital(selectedRole.code)
      } else {
        this.level = 3 // 社区管理
        this.rangeOptions = [
          { label: '社区', value: 'hospital' },
          { label: '团队', value: 'team' }
        ]
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code.substring(0, 6) }]
        this.hospitalOptions = [{ name: selectedRole.name, code: selectedRole.code }]
        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code
        }
        this.getTeam(selectedRole.code)
      }
      this.initTime()
      this.searchFn()
    },
    initTime() {
      var vm = this
      var now = new Date()

      var nowyear = (vm.chooseYear = now.getFullYear())
      vm.years = []
      for (i = nowyear; i >= 2013; i--) {
        vm.years.push(i)
      }
    },
    resetArea() {
      if (this.level == 1) {
        delete this.form.area
        delete this.form.hospital
        delete this.form.team
      } else if (this.level == 2) {
        delete this.form.hospital
        delete this.form.team
      } else {
        delete this.form.team
      }
    },
    searchFn() {
      var vm = this
      this.loading = true
      var params = {
        ...this.form,
        isTotal: 1
      }
      vm.tableData = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      if (this.form.range == 'town') {
        this.tableHeader = getTownHeader().concat(this.constantHeader)
      } else if (this.form.range == 'hospital') {
        this.tableHeader = getHospitalHeader().concat(this.constantHeader)
      } else {
        this.tableHeader = getTeamHeader().concat(this.constantHeader)
      }
      // constantHeader

      httpRequest.get('statistics/collaborate/gxbScreenInfoStatistics', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.tableData = res.detailModelList.map(function (item) {
            var data = JSON.parse(JSON.stringify(item))
            if (vm.form.range == 'town') {
              data.town = item.name
              data.hasChildren = item.code && true
            } else if (vm.form.range == 'hospital') {
              data.hospital = item.name
              data.hasChildren = item.code && true
            } else if (vm.form.range == 'team') {
              data.team = item.name
            }
            return data
          })
        }
        vm.loading = false
      })
    },
    exportTable() {
      var vm = this
      var params = {
        ...this.form
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      this.exportLoading = true
      var fileName = `冠心病评估情况统计表${new Date().getTime()}.xls`
      httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbScreenInfoStatistics', fileName, params).then(function () {
        vm.exportLoading = false
      })
    },
    eliminateClick() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (this.level == 1) {
        this.form = {
          range: 'town'
        }
      } else if (this.level == 2) {
        this.form = {
          range: 'town',
          area: selectedRole.code
        }
        this.getHospital(selectedRole.code)
      } else {
        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code
        }
        this.getTeam(selectedRole.code)
      }
      this.yearType = '1'
      this.chooseYear = new Date().getFullYear()
      this.chooseTime = null
      this.$forceUpdate()
    },
    getHospital(code, flag = true) {
      var vm = this
      if (flag) {
        delete this.form.hospital
        delete this.form.team
      }
      var params = {
        type: 5,
        code: code
      }
      httpRequest.post('common/district', { data: params }).then(function (res) {
        vm.hospitalOptions = [{ code: '', name: '全部' }]
        vm.hospitalOptions = vm.hospitalOptions.concat(res.list)
      })
    },
    getTeam(code, flag = true) {
      var vm = this
      if (flag) delete this.form.team
      var params = {
        hospital: code,
        area: this.form.area
      }
      httpRequest.get('statisticsExport/teamList', { data: params }).then(function (res) {
        vm.teamOptions = [{ id: '', name: '全部' }]
        vm.teamOptions = vm.teamOptions.concat(res.data)
      })
    },
    load(row, treeNode, resolve) {
      var params = {}
      var len = row.code.length
      if (len == 6) {
        params.range = 'hospital'
        params.area = row.code
      } else if (len == 10) {
        params.range = 'team'
        params.hospital = row.code
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/gxbScreenInfoStatistics', { data: params }).then(function (res) {
        if (res.status == 200) {
          var children = res.detailModelList.map(function (item) {
            var data = JSON.parse(JSON.stringify(item))
            if (len == 6) {
              data.hospital = item.name
              data.hasChildren = true
            } else if (len == 10) {
              data.team = item.name
            }
            return data
          })

          resolve(children)
        }
      })
    },
    openDialog(row, prop) {
      if (!row.code) return
      this.page = 1
      var vm = this
      this.query = {}
      switch (prop) {
        case 'totalNum':
          this.query.screenResultCode = ''
          this.title = '个案数据列表'
          break
        case 'dailyNum':
          this.query.screenResultCode = ''
          this.query.surveyStatus = 1
          this.title = '个案数据列表'
          break
        case 'inScreenNum':
          this.query.screenResultCode = ''
          this.query.surveyStatus = 2
          this.title = '个案数据列表'
          break
        case 'lRiskNum':
          this.query.screenResultCode = '5'
          this.title = '个案数据列表'
          break
        case 'mRiskNum':
          this.query.screenResultCode = '4'
          this.title = '个案数据列表'
          break
        case 'hRiskNum':
          this.query.screenResultCode = '3'
          this.title = '个案数据列表'
          break
        case 'uhRiskNum':
          this.query.screenResultCode = '2'
          this.title = '个案数据列表'
          break
        case 'ehRiskNum':
          this.query.screenResultCode = '1'
          this.title = '个案数据列表'
          break
        case 'messageTimes':
          this.title = '评估随访消息推送明细'
          break
      }
      var len = row.code.length
      if (len == 6) {
        this.query.range = 'town'
        this.query.area = row.code
      } else if (len == 10) {
        this.query.range = 'hospital'
        this.query
        this.query.hospital = row.code
      } else {
        this.query.range = 'team'
        this.query.team = row.code
      }
      this.dataRangeOption = [{ label: row.name, value: row.code }]
      if (['totalNum', 'dailyNum', 'inScreenNum', 'lRiskNum', 'mRiskNum', 'hRiskNum', 'uhRiskNum', 'ehRiskNum'].includes(prop)) {
        this.query.sex = ''
        vm.dialogHeader = [
          { label: '姓名', prop: 'name' },
          { label: '性别', prop: 'sex' },
          { label: '年龄', prop: 'age' },
          { label: '评估结果', prop: 'screenResult' },
          { label: '评估医生', prop: 'doctorName' },
          { label: '评估时间', prop: 'czrq' },
          { label: '手机号', prop: 'mobile' },
          { label: '证件号码', prop: 'idcard' },
          { label: '签约社区', prop: 'signHospitalName' },
          { label: '签约医生', prop: 'signDoctorName' }
        ]
        this.gxbCaseDataPage()
        vm.visible = true
      }
      if (prop == 'messageTimes') {
        vm.dialogHeader = [
          { label: '姓名', prop: 'patientName' },
          { label: '性别', prop: 'sex' },
          { label: '年龄', prop: 'age' },
          { label: '证件号码', prop: 'idcard' },
          { label: '签约医院', prop: 'hospitalName' },
          { label: '签约医生', prop: 'doctorName' },
          { label: '提醒类型', prop: 'typeName' },
          { label: '消息推送时间', prop: 'createTime' },
          { label: '消息推送人', prop: 'senderName' }
        ]
        this.selectSmsInfoList()
        vm.visible = true
      }
    },
    dialogSearchFn() {
      this.page = 1
      if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      } else {
        this.selectSmsInfoList()
      }
    },
    gxbCaseDataPage() {
      var vm = this
      vm.dialogLoading = true
      var params = JSON.parse(JSON.stringify(this.query))
      params.page = this.page
      params.pageSize = this.size
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }

      httpRequest.get('statistics/collaborate/gxbCaseDataPage', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dialogTableData = res.detailModelList
          vm.total = res.totalCount
        }
        vm.dialogLoading = false
      })
    },
    handleCurrentChange(val) {
      this.page = val
      if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      } else {
        this.selectSmsInfoList()
      }
    },
    handleSizeChange(val) {
      this.size = val
      if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      } else {
        this.selectSmsInfoList()
      }
    },
    selectSmsInfoList() {
      var vm = this
      vm.dialogLoading = true
      var params = {
        ...this.query
      }
      params.type = 1
      params.page = this.page
      params.size = this.size
      if (this.yearType == '1') {
        params.startTime = this.chooseYear + '-01-01'
        params.endTime = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startTime = this.chooseTime[0]
          params.endTime = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/selectSmsInfoList', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dialogTableData = res.detailModelList
          vm.total = res.totalCount
        }
        vm.dialogLoading = false
      })
    },
    dialogExportFn() {
      this.dialogExportLoading = true
      var vm = this
      var params = {
        ...this.query
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }

      if (this.title == '个案数据列表') {
        var fileName = `个案数据列表${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbCaseDataPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      } else {
        var fileName = `评估随访消息推送明细${new Date().getTime()}.xls`
        params.type = 1
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportSelectSmsInfoList', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      }
    },
    closeDialog() {
      this.visible = false
    },
    seePatientDetail(row, prop) {
      if (prop == 'name' || prop == 'patientName') {
        EventBus.$emit('preview-person-info', { type: '1', code: row.code })
      }
    },
    dialogReset() {
      var params = {
        ...this.query
      }
      this.query = {
        sex: '',
        screenResultCode: '',
        type: params.type,
        range: typeof params.range == 'undefined' ? '' : params.range,
        area: typeof params.area == 'undefined' ? '' : params.area,
        hospital: typeof params.hospital == 'undefined' ? '' : params.hospital,
        team: typeof params.team == 'undefined' ? '' : params.team
      }
      if (this.title != '评估随访消息推送明细') {
        delete this.query.type
      }
    },
    previewMess(row) {
      this.messageVisible = true
      this.messInfo = row.content
    },
    closeMessageDialog() {
      this.messageVisible = false
    },
    getData(data) {
      if (data) {
        this.yearType = data.yearType
        this.form.range = data.range
        this.form.area = data.area

        this.form.hospital = data.hospital
        this.form.team = data.team

        if (this.yearType == 1) {
          this.chooseYear = data.time
        } else {
          this.chooseTime = data.time
        }
        if (this.form.hospital) {
          // 如果有社区code传过来就调社区医院列表接口
          this.getHospital(data.area, false)
        }
        if (this.form.team) {
          // 如果有团队code传过来就调团队列表接口
          this.getTeam(data.hospital, false)
        }
        this.searchFn()
      } else {
        this.init()
      }
    },
    renderHeader: function (h, item) {
      var label = item.column.label
      var column = item.column
      var tooltip = {
        '签约社区': '显示为该患者当前的签约社区医院名称',
        '社区医院': '显示为该患者当前的签约社区医院名称',
        '签约医院': '显示为该患者当前的签约社区医院名称',
        '签约医生': '显示为该患者当前的签约社区医生名称',
        '家庭医生': '显示为该患者当前的签约社区医生名称'
      }

      if (label == '签约社区' || label == '签约医生' || label == '签约医院' || label == '家庭医生' || label == '社区医院') {
        return [
          label,
          h(
            'el-tooltip',
            {
              props: {
                content: (function () {
                  return tooltip[label]
                })(),
                placement: 'top'
              }
            },
            [
              h('span', {
                class: {
                  'el-icon-question': true
                }
              })
            ]
          )
        ]
      } else {
        return [column.label]
      }
    }
  },
  mounted() {
    // this.init()
  }
})
