var template = ''
$.ajax('../../../component/statistics/MoneyReward/index.html', {
  data: {},
  dataType: 'html',
  cache: false,
  timeout: 60000,
  async: false,
  error: function (res) {},
  success: function (res) {
    template = res
  }
})

Vue.component('money-reward', {
  template: template,
  props: {
    header: {}
  },
  data() {
    return {
      years: [],
      yearType: '1',
      chooseYear: null,
      chooseTime: null,
      form: {
        range: 'town',
        serviceType: ''
      },
      tableData: [],
      dialogShow: false,
      page: 1,
      size: 10,
      total: 0,
      page1: 1,
      size1: 10,
      total1: 0,
      loading: false,
      exportLoading: false,
      sexDict: {
        1: '男',
        2: '女'
      },
      rangeOptions: [
        { label: '按区', value: 'town' },
        { label: '按社区', value: 'hospital' }
      ],
      areaOptions: [
        { label: '思明区', value: '350203' },
        { label: '海沧区', value: '350205' },
        { label: '湖里区', value: '350206' },
        { label: '集美区', value: '350211' },
        { label: '同安区', value: '350212' },
        { label: '翔安区', value: '350213' }
      ],
      level: 0,
      tableHeader: [],
      serviceType: [],
      hospitalOptions: []
    }
  },
  watch: {
    header: {
      handler() {
        if (this.form.range == 'town') {
          this.tableHeader = [
            { label: '地区', prop: 'town', width: '120' },
            { label: '社区', prop: 'hospital', width: '140' }
          ].concat(this.header)
        } else if (this.form.range == 'hospital') {
          this.tableHeader = [{ label: '社区', prop: 'hospital', width: '140' }].concat(this.header)
        }
      }
    }
  },
  methods: {
    init() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (selectedRole.code.indexOf('350200') > -1) {
        this.level = 1 //  市卫健委
        this.areaOptions = [
          { label: '思明区', value: '350203' },
          { label: '海沧区', value: '350205' },
          { label: '湖里区', value: '350206' },
          { label: '集美区', value: '350211' },
          { label: '同安区', value: '350212' },
          { label: '翔安区', value: '350213' }
        ]
      } else if (selectedRole.code.length == 6) {
        this.level = 2 // 区管理
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code }]
        this.form = {
          range: 'town',
          area: selectedRole.code,
          serviceType: ''
        }
        this.getHospital(selectedRole.code)
      } else {
        this.rangeOptions = [{ label: '按社区', value: 'hospital' }]

        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code,
          serviceType: ''
        }
        this.level = 3 // 社区管理
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code.substring(0, 6) }]
        this.hospitalOptions = [{ name: selectedRole.name, code: selectedRole.code }]
      }
      this.initTime()
      this.searchFn()
    },
    initTime() {
      var vm = this
      var now = new Date()

      vm.nowyear = vm.chooseYear = now.getFullYear()
      vm.years = []
      for (i = vm.nowyear; i >= 2013; i--) {
        vm.years.push(i)
      }
    },
    searchFn() {
      var vm = this
      this.loading = true
      var params = {
        ...this.form,
        isTotal: 1,
        menu: this.header
          .map(function (item) {
            return item.prop
          })
          .join(',')
      }
      vm.tableData = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('doctor/healthBank/redPackageRewardStatistics', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.tableData = res.data.list.map(function (item) {
            var data = JSON.parse(JSON.stringify(item))
            if (vm.form.range == 'town') {
              data.town = item.name
              data.hasChildren = item.code && true
            } else if (vm.form.range == 'hospital') {
              data.hospital = item.name
              data.hasChildren = false
            }
            return data
          })
        }
        vm.loading = false
      })
    },
    exportTable() {
      var vm = this
      var params = {
        ...this.form,
        menu: this.header
          .map(function (item) {
            return item.prop
          })
          .join(',')
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      this.exportLoading = true
      var fileName = `红包奖励汇总${new Date().getTime()}.xls`

      httpRequest.downLoadFileForAjax('/doctor/healthBank/exportRedPackageRewardStatistics', fileName, params).then(function () {
        vm.exportLoading = false
      })
    },
    eliminateClick() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (this.level == 1) {
        this.form = {
          range: 'town',
          serviceType: ''
        }
      } else if (this.level == 2) {
        this.form = {
          range: 'town',
          area: selectedRole.code,
          serviceType: ''
        }
        this.getHospital(selectedRole.code)
      } else {
        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code,
          serviceType: ''
        }
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code.substring(0, 6) }]
        this.hospitalOptions = [{ name: selectedRole.name, code: selectedRole.code }]
      }

      this.yearType = '1'
      this.chooseYear = new Date().getFullYear()
      this.chooseTime = null
      this.$forceUpdate()
    },
    closeDialog() {
      this.dialogShow = false
      this.dialogShow1 = false
    },
    getDictData() {
      var vm = this
      statisticAPI.getDictByDictName({ name: 'health_bank_service_type' }).then(function (res) {
        vm.serviceType = [{ label: '全部', value: '' }].concat(res.list)
      })
    },
    getHospital(code) {
      var vm = this
      delete this.form.hospital
      delete this.form.team
      var params = {
        type: 5,
        code: code
      }
      httpRequest.post('common/district', { data: params }).then(function (res) {
        vm.hospitalOptions = [{ code: '', name: '全部' }]
        vm.hospitalOptions = vm.hospitalOptions.concat(res.list)
      })
    },
    resetArea() {
      if (this.level == 1) {
        delete this.form.area
        delete this.form.hospital
        delete this.form.team
      } else if (this.level == 2) {
        delete this.form.hospital
        delete this.form.team
      } else {
        delete this.form.team
      }
    },
    load(row, treeNode, resolve) {
      var params = {
        menu: this.header
          .map(function (item) {
            return item.prop
          })
          .join(',')
      }
      var len = row.code.length
      if (len == 6) {
        params.range = 'hospital'
        params.area = row.code
      } else if (len == 10) {
        params.range = 'team'
        params.hospital = row.code
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('doctor/healthBank/redPackageRewardStatistics', { data: params }).then(function (res) {
        if (res.status == 200) {
          var children = res.data.list.map(function (item) {
            var data = {
              ...item
            }

            if (len == 6) {
              data.hospital = item.name
              data.hasChildren = false
              data.town1 = row.code
            }
            return data
          })

          resolve(children)
        }
      })
    }
  },
  mounted() {
    this.init()
    this.getDictData()
  }
})
